/////////////////////////////////////////
// modul pro zakladni funkce (usecky)  //
/////////////////////////////////////////

typedef unsigned int word;
typedef unsigned char byte;

#include "mnghw.h"
#include "queue.h"
#include "base.h"

#define abs(c) ((c) >= 0 ? c : -c)

int RealyX, RealyY; // skutecne souradnice bodu [0,0]
int PenX, PenY;		// absolutni souradnice
TPenState PenState, LastPen;
TMoveMode MoveMode;
bit PenPoint;

void mngProc(void)
{       
	hwSet(PenX % 8, PenY % 8, (unsigned char)PenState);
}

// vrati rychlost podle polohy
// maximalni je dvojnasobkem pomale
word GetRychlost(word x, word dx, bit pomalu)
{
	if (rychlost < 0 || pomalu || x < rychlost)	// pro tupe uhly uhly pomalu, jinak zacne drhnout
		return abs(2*rychlost);

	if (dx < rychlost)
		return 2*rychlost - dx;
	if (dx > (x-rychlost))
		return 2*rychlost - (x - dx);
	return rychlost;
}

void mngInit(void)	// inicializace papiru na polohu x,y
{
	PenX = 0;
	PenY = PAPERYINIT;
	PenState = Up;
	MoveMode = Absolut;
	mngPen(Up);
	mngProc();
}

void mngRMove(int xi, int yi)	// relativni posun
{
	unsigned int i;
	word numpixels;
	int d, dinc1, dinc2;
	char xinc1, xinc2;
	char yinc1, yinc2;
	byte pomalu;
	word deltax, deltay;

	mngSleep(0);
	timeout = 0;

	deltax = abs(xi);
	deltay = abs(yi);

	if (deltax >= deltay) {
		numpixels = deltax;
		pomalu = (deltax - 2*deltay) < 0;
		d = (2*deltay) - deltax;
		dinc1 = 2*deltay;
		dinc2 = 2*(deltay - deltax);
		xinc1 = 1;
		xinc2 = 1;
		yinc1 = 0;
		yinc2 = 1;
	} else {
		numpixels = deltay;
		pomalu = (deltay - 2*deltax) < 0;
		d = (2*deltax) - deltay;
		dinc1 = 2*deltax;
		dinc2 = 2*(deltax - deltay);
		xinc1 = 0;
		xinc2 = 1;
		yinc1 = 1;
		yinc2 = 1;
	}
	if (deltax == deltay)		// vyjimka pro 45stupnu
		pomalu = 0;
	
	if (xi < 0) {
		xinc1 = -xinc1;
		xinc2 = -xinc2;
	}
	if (yi < 0) {
		yinc1 = -yinc1;
		yinc2 = -yinc2;
	}

	if (deltax != 0 || deltay != 0) {	// pohyb pera
		if (PenState != LastPen) {
			mngProc();
			hwWait(T_PERO);
			LastPen = PenState;
		}
		if (PenState == Up && LastPen == Up && PenPoint) {
			PenState = Down;
			mngProc();
			hwWait(T_PERO);
			PenState = Up;
			mngProc();
			hwWait(T_PERO);
		}
		PenPoint = 0;
	}

	for (i = 0; i < numpixels; i++) {
		if (d < 0) {
			d += dinc1;
			PenX += xinc1;
			PenY += yinc1;
		} else {
			d += dinc2;
			PenX += xinc2;
			PenY += yinc2;
		}
		mngProc();
		hwWait(GetRychlost(numpixels-1, i, pomalu));
	}
}

void mngAMove(int xi, int yi)	// absolutni posun
{
	mngRMove(xi-PenX, yi-PenY);
}

void mngPen(TPenState pen)
{
	PenState = pen;
	if (pen == Down)	// bodik
		PenPoint = 1;
}

void mngSleep(bit sleep)	// sleep plotru (offline)
{
	static bit oldsleep = 0;
	TPenState SleepPen; 

	if (oldsleep == 0) {
		if (sleep) {
			SleepPen = PenState;
			PenState = Up;
			mngProc();
			hwWait(T_PERO);
			PenState = SleepPen;
			oldsleep = sleep;
		}
	} else {
		if (!sleep) {
			mngProc();
			hwWait(T_PERO);
			oldsleep = sleep;
		}
	}
}
